/***************************************************************************
 *            wb.c
 *
 *  Sat Dec  4 16:48:41 2004
 *  Copyright  2004  Marcin K. Krzywonos
 *  mkk@gnutu.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "bw.h"
#include "var.h"
#include "mw.h"


/*
 * Funkcja tworzy kopie zapasowa
 */
int bw_make_backup ()
{
	GtkWidget *bw_backup_file_entry_fn = (gpointer) lookup_widget (GTK_WIDGET (bw_widget), "bw_backup_file_entry_fn");
	GtkWidget *bw_compress_check_btn   = (gpointer) lookup_widget (GTK_WIDGET (bw_widget), "bw_compress_check_btn");
	gchar      command [2048];
	gchar      ext     [10];
	gchar      arg     [10];
	
	
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (bw_compress_check_btn)) == TRUE) {
		strcpy (ext, ".tar.gz");
		strcpy (arg, "-zcvf");
	} else {
		strcpy (ext, ".tar");
		strcpy (arg, "-cvf");
	}
	
	gtudb_write ();
	gtudb_read  ();
	
	if (gtk_entry_get_text (GTK_ENTRY (bw_backup_file_entry_fn)) == 0) {
		sprintf (command, "cd ~; tar %d gnutu-backup-%d-%d-%d.%s .gnutu", arg, date_today ().day, date_today ().month, date_today ().year, ext);
		system  (command);
	}
	
	
	sprintf (command, "cd ~; tar %s %s%s .gnutu", arg, gtk_entry_get_text (GTK_ENTRY (bw_backup_file_entry_fn)), ext);
	system  (command);
	
	gnome_app_message (GNOME_APP (mw_widget), _("Kopia zapasowa zostala utworzona !"));
}


/*
 * Funkcja wczytuje kopie zapasowa
 */
int bw_load_backup ()
{
	GtkWidget *lbw_backup_file_entry_fn = (gpointer) lookup_widget (GTK_WIDGET (lbw_widget), "lbw_backup_file_entry_fn");
	gchar      command [2048];
	
	
	if (strlen (gtk_entry_get_text (GTK_ENTRY (lbw_backup_file_entry_fn))) == 0) {
		gnome_app_message (GNOME_APP (mw_widget), _("Nie wybrales zadnego pliku !"));
	} else {
		strcpy (command, gtk_entry_get_text (GTK_ENTRY (lbw_backup_file_entry_fn)));
		if (command[strlen (command) - 1] == 'r') // jesli rozszerzeniem pliku jest .tar
			sprintf (command, "cd ~; tar -xvf %s", gtk_entry_get_text (GTK_ENTRY (lbw_backup_file_entry_fn)));
		else
			sprintf (command, "cd ~; tar -zxvf %s", gtk_entry_get_text (GTK_ENTRY (lbw_backup_file_entry_fn)));
		
		
		system  (command);
		
		gtudb_read ();
		gtudb_settings_read ();
		gtudb_plan_read ();
		entry_date = date_today ();
		mw_edit_entry (entry_date, FALSE);
		
		gnome_app_message (GNOME_APP (mw_widget), _("Kopia zapasowa zostala wczytana !"));
	}
}
