/***************************************************************************
 *            db.h
 *
 *  Fri Sep  3 19:20:25 2004
 *  Copyright  2004  Marcin K. Krzywonos
 *  mkk@gnutu.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


typedef struct {
	gchar     *name;
	gchar     *marks;
	gchar     *time;
	gchar      flag;  // 0 - brak; 1 - kartkowka; 2 - sprawdzian
} GTUDBSubject;


typedef struct {
	type_date  date;
	GSList    *subjects;
	gchar     *notes;
} GTUDBEntry;


typedef struct {
	gchar *key;
	gchar *value;
} GTUDBSettings;


typedef struct {
	type_date  date;
	gchar     *desc;
} GTUDBFreeDays;


GSList *gtudb_list;          // Lista z baza wpisow
GSList *gtudb_plan_list[7];  // Tablica z 7 listami z planu lekcji
GSList *gtudb_settings_list; // Lista z baza ustawien
GSList *gtudb_fd_list;       // Lista z baza wolnych dni


int       gtudb_read                    ();
int       gtudb_write                   ();
int       gtudb_search_entry            (type_date date);
GSList   *gtudb_search_test             ();
int       gtudb_entry_search_tests      (type_date date);
int       gtudb_entry_search_test_od    (type_date date);
GSList   *gtudb_entry_get_subjects_list (type_date date, int flag);

int       gtudb_plan_read               ();
int       gtudb_plan_write              ();
int       gtudb_plan_num_hours          (gboolean save);

int       gtudb_settings_read           ();
int       gtudb_settings_write          ();
gchar    *gtudb_settings_get_value      (gchar *key);
int       gtudb_settings_set_value      (gchar *key, gchar *value);

int       gtudb_fd_read                 ();
int       gtudb_fd_write                ();
int       gtudb_fd_search_day           (type_date date);

gchar    *gtudb_text_to_notes           (gchar *text);
gchar    *gtudb_notes_to_text           (gchar *text);
