/***************************************************************************
 *            pw.c
 *
 *  Sat Oct 16 08:55:25 2004
 *  Copyright  2004  Marcin K. Krzywonos
 *  mkk@gnutu.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "pw.h"
#include "var.h"
#include "gtudb.h"
#include "mw.h"
#include "interface.h"


/*
 * Funkcja wywolywana przy wyswietleniu glownego okna
 */
int pw_show ()
{
	pw_widget = create_plan_window ();
	
	if (g_slist_length (gtudb_plan_list [0]) == 0) {
		pwmh_widget = create_plan_window_msg_hours ();
		gtk_widget_show (GTK_WIDGET (pwmh_widget));
	} else {
		pw_load_subjects ();
		pw_enable_buttons ();
		gtk_widget_show (pw_widget);
	}
}


/*
 * Funkcja wstawia przedmioty z planu lekcji do tabeli przedmiotow i ocen
 */
int pw_load_subjects ()
{
	GtkWidget *pw_plan_clist  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_plan_clist");
	gtk_clist_clear (GTK_CLIST (pw_plan_clist));
	
	gchar *tmp [7] = {"", "", "", "", "", "", ""};
	int    x       = 0;
	
	while (x < g_slist_length (gtudb_plan_list [0])) {
		int y = 0;
		
		while (y < 7) {
			if (g_slist_length (gtudb_plan_list [y]) > x)
				tmp [y] = g_strdup (g_slist_nth (gtudb_plan_list [y], x)->data);
			else
				tmp [y] = "";
			
			y++;
		}
		
		gtk_clist_append (GTK_CLIST (pw_plan_clist), tmp);
		
		x++;
	}
}


/*
 * Funkcja pozwala na dzialanie przyciskow w planie lekcji
 */
int pw_enable_buttons ()
{
	GtkWidget *pw_edit_d1_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d1_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d1_btn), TRUE);
	
	GtkWidget *pw_edit_d2_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d2_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d2_btn), TRUE);
	
	GtkWidget *pw_edit_d3_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d3_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d3_btn), TRUE);
	
	GtkWidget *pw_edit_d4_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d4_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d4_btn), TRUE);
	
	GtkWidget *pw_edit_d5_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d5_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d5_btn), TRUE);
	
	GtkWidget *pw_edit_d6_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d6_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d6_btn), TRUE);
	
	return 0;
}


/*
 * Funkcja zabrania dzialania przyciskow w planie lekcji
 */
int pw_disable_buttons ()
{
	GtkWidget *pw_edit_d1_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d1_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d1_btn), FALSE);
	
	GtkWidget *pw_edit_d2_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d2_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d2_btn), FALSE);
	
	GtkWidget *pw_edit_d3_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d3_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d3_btn), FALSE);
	
	GtkWidget *pw_edit_d4_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d4_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d4_btn), FALSE);
	
	GtkWidget *pw_edit_d5_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d5_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d5_btn), FALSE);
	
	GtkWidget *pw_edit_d6_btn  = (gpointer) lookup_widget (GTK_WIDGET (pw_widget), "pw_edit_d6_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (pw_edit_d6_btn), FALSE);
	
	return 0;
}


/*
 * Funkcja wczytuje godziny w oknie edit_plan_hours_window
 */
int pw_ephw_load_hours ()
{
	GtkWidget *ephw_hours_clist = (gpointer) lookup_widget (GTK_WIDGET (ephw_widget), "ephw_hours_clist");
	gtk_clist_clear (GTK_CLIST (ephw_hours_clist));
		
	gchar *tmp [1] = {""};
	int    i       = 0;
	
	while (i < g_slist_length (gtudb_plan_list [0])) {
		tmp[0] = g_strdup (g_slist_nth (gtudb_plan_list[0], i)->data);
		gtk_clist_append (GTK_CLIST (ephw_hours_clist), tmp);
		
		i++;
	}
}


/*
 * Funkcja wczytuje do listy epw_subjects_clist liste przedmiotow z dnia
 * o numerze zapisanym w zmiennej "day"
 */
int pw_epw_load_subjects (int day)
{
	GtkWidget *epw_subjects_clist = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_subjects_clist");
	
	gtk_clist_clear (GTK_CLIST (epw_subjects_clist));
	
	gchar *tmp [2] = {"", ""}; // tmp[0] - godzina, tmp[1] - nazwa przedmiotu
	int    i       = 0;
	
	while (i < g_slist_length (gtudb_plan_list [0])) {
		tmp[0] = g_strdup (g_slist_nth (gtudb_plan_list[0], i)->data);
		
		if (g_slist_length (gtudb_plan_list [day]) > i) {
			tmp[1] = g_strdup (g_slist_nth (gtudb_plan_list[day], i)->data);
			
			if (strlen (tmp[1]) > 0) {
				gtk_clist_append (GTK_CLIST (epw_subjects_clist), tmp);
			} else {
				pw_epw_time_clist_add (tmp[0]);
				tmp[1] = "";
			}
		} else {
			tmp[1] = "";
		}
		
		if (g_slist_length (gtudb_plan_list [day]) <= i)
			pw_epw_time_clist_add (tmp[0]);
		
		i++;
	}
}


/*
 * Funkcja dodaje do listy godzin godzine "hour"
 */
int pw_ephw_add_hour (gchar *hour)
{
	if (strlen (hour) == 0)
		return -1;
	
	GtkWidget *ephw_hours_clist = (gpointer) lookup_widget (GTK_WIDGET (ephw_widget), "ephw_hours_clist");
	
	gchar *tmp [1] = {""};
	gchar  hr2 [20];
	
	if (hour [1] == ':') {
		sprintf (hr2, "0%s", hour);
		tmp [0] = hr2;
	} else {
		tmp [0] = hour;
	}
	
	gtk_clist_append (GTK_CLIST (ephw_hours_clist), tmp);
	gtk_clist_sort (GTK_CLIST (ephw_hours_clist));
	
	return 0;
}


/*
 * Funkcja usuwa godzine z listy godzin
 */
int pw_ephw_remove_hour (int id)
{
	GtkWidget *ephw_hours_clist = (gpointer) lookup_widget (GTK_WIDGET (ephw_widget), "ephw_hours_clist");
	
	if (id >= 0)
		gtk_clist_remove (GTK_CLIST (ephw_hours_clist), id);
}


/*
 * Funkcja usuwa godzine z listy godzin
 */
int pw_ephw_get_hours ()
{
	GtkWidget *ephw_hours_clist = (gpointer) lookup_widget (GTK_WIDGET (ephw_widget), "ephw_hours_clist");
	gchar *tmp;
	int   i = 0;
	
	gtudb_plan_list [0] = NULL;
	
	while (gtk_clist_get_text (GTK_CLIST (ephw_hours_clist), i, 0, &tmp) == 1) {
		gtudb_plan_list [0] = g_slist_append (gtudb_plan_list [0], g_strdup (tmp));
		
		i++;
	}
}


/*
 * Funkcja dodaje przedmiot "subject" i godzine "hour" do listy przedmiotow
 */
int pw_epw_add_subject (gchar *subject, gchar *hour)
{
	if ((strlen (subject) == 0) || (strlen (hour) == 0)) {
		return -1;
	}
	
	GtkWidget *epw_subjects_clist = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_subjects_clist");
	
	gchar *tmp [2] = {"", ""};
	tmp[0] = g_strdup (hour);
	tmp[1] = g_strdup (subject);
	
	gtk_clist_append (GTK_CLIST (epw_subjects_clist), tmp);
	gtk_clist_sort (GTK_CLIST (epw_subjects_clist));
	
	GtkWidget *epw_add_btn = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_add_btn");
	gtk_widget_set_sensitive (GTK_WIDGET (epw_add_btn), FALSE);
}


/*
 * Funkcja usuwa przedmiot o numerze "id" z listy przedmiotow
 */
int pw_epw_remove_subject (int id)
{
	GtkWidget *epw_subjects_clist = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_subjects_clist");
	
	if (id != -1)
		gtk_clist_remove (GTK_CLIST (epw_subjects_clist), id);
}


/*
 * Funkcja pobiera przedmioty i zapisuje w liscie gtudb_plan_list
 */
int pw_epw_get_subjects ()
{
	int   i = 0;
	
	gtudb_plan_list [pw_epw_edit_day] = NULL;
	
	while (i < g_slist_length (gtudb_plan_list [0])) {
		gtudb_plan_list [pw_epw_edit_day] = g_slist_append (gtudb_plan_list [pw_epw_edit_day], pw_epw_search_time (g_strdup ((gchar *) g_slist_nth (gtudb_plan_list [0], i)->data)));
		i++;
	}
}


/*
 * Funkcja zwraca nazwe przedmiotu do ktorego jest przypisana godzina "hour"
 */
gchar *pw_epw_search_time (gchar *hour)
{
	GtkWidget *epw_subjects_clist = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_subjects_clist");
	gchar     *tmp_sub, *tmp_time;
	int        i = 0;
	
	while (gtk_clist_get_text (GTK_CLIST (epw_subjects_clist), i, 0, &tmp_time) == 1) {
		gtk_clist_get_text (GTK_CLIST (epw_subjects_clist), i, 1, &tmp_sub);
		
		if (strcmp (tmp_time, hour) == 0)
			return tmp_sub;
		
		i++;
	}
	
	return "";
}


/*
 * Funkcja dodaje pozycje "time" do listy "epw_time_clist"
 */
int pw_epw_time_clist_add (gchar *time)
{
	GtkWidget *epw_time_clist = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_time_clist");
	gchar     *tmp [1]        = {""};
	
	tmp [0] = time;
	
	gtk_clist_prepend (GTK_CLIST (epw_time_clist), tmp);
	gtk_clist_sort    (GTK_CLIST (epw_time_clist));
	
	return 0;
}


/*
 * Funkcja usuwa pozycje o numerze "id" z listy "epw_time_clist"
 */
int pw_epw_time_clist_remove (int id)
{
	if (id < 0)
		return 1;
	
	GtkWidget *epw_time_clist = (gpointer) lookup_widget (GTK_WIDGET (epw_widget), "epw_time_clist");
	
	gtk_clist_remove (GTK_CLIST (epw_time_clist), id);
	return 0;
}
